import java.io.FileWriter;
import java.io.IOException;

public class CodeWriter {

	// The HACK asm file we're writing the translated VM commands to.
	private FileWriter asmFile;
	
	// Basename of the current .vm file we're translated.  Used for push/pop commands
	// to/from the static segment
	private String fileName = "";
	
	// functioName is used in the second part of the VM translator, Project 8.
	// It is set in writeFunction() and used in writeLabel(), writeIf(), and writeCall(). 
	private String functionName = "";
	

	public CodeWriter(String basename) {
		try { // Open the ASM file for writing.
			asmFile = new FileWriter(basename + ".asm");
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	

	// This is a helper method.
	// Write a sequence of ASM code to the ASM file.
	// The parameter code is expected to contain all necessary newline
	// characters.
	private void writeCode(String code) {
		try {
			asmFile.write(code);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	
	public void setFileName(String fileName) {
		this.fileName = fileName;
		functionName = "";
	}

	
	public void close() {
		try {
			asmFile.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	
	public void writeArithmetic(String op) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writePushPop(CommandType op, String seg, int idx) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}
	
	
	/***********************************************************************
	 * The following methods will be completed for the second part of the
	 * VM translator, Project 8.
	 ***********************************************************************/

	
	public void writeInit() {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writeLabel(String label) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writeGoto(String label) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writeIf(String label) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writeCall(String fName, int nArgs) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writeReturn() {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}

	
	public void writeFunction(String fName, int nLocals) {
		String code = "";

		// Add code completing the method here.

		writeCode(code);
	}
}